<?php
/**
* @version      2.2.6 24.09.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

class jshopCategory extends JTableAvto {
    
    function __construct( &$_db ){
        parent::__construct( '#__jshopping_categories', 'category_id', $_db );
    }
    
    function getSubCategories($parentId, $order = 'id', $ordering = 'asc', $publish = 0) {
        $lang = &JSFactory::getLang(); 
        $add_where = ($publish)?(" AND category_publish = '1' "):("");        
        if ($order=="id") $orderby = "category_id";
        if ($order=="name") $orderby = "`".$lang->get('name')."`";
        if ($order=="ordering") $orderby = "category_ordering";
        if (!$orderby) $orderby = "category_ordering";
        
        $query = "SELECT `".$lang->get('name')."` as name,`".$lang->get('description')."` as description,`".$lang->get('short_description')."` as short_description, category_id, category_publish, category_ordering, category_image FROM `#__jshopping_categories`
                   WHERE category_parent_id = '" . $this->_db->getEscaped($parentId) . "'" . $add_where . "
                   ORDER BY ".$orderby." ".$ordering;
        $this->_db->setQuery($query);
        $categories = $this->_db->loadObjectList();
                
        foreach ($categories as $key => $value){
            $categories[$key]->category_link = SEFLink('index.php?option=com_jshopping&controller=category&task=view&category_id='.$categories[$key]->category_id, 1);
        }
                
        return $categories;
    }

    function getName() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        return $this->$name;
    }
    
    function getDescription(){
        
        if (!$this->category_id){
            $this->getDescriptionMainPage();
            return 1; 
        }
        
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');        
        $description = $lang->get('description');
        $short_description = $lang->get('short_description');
        $meta_title = $lang->get('meta_title');
        $meta_keyword = $lang->get('meta_keyword');
        $meta_description = $lang->get('meta_description');
        
        $this->name = $this->$name;
        $this->description = $this->$description;
        $this->short_description = $this->$short_description;
        $this->meta_title = $this->$meta_title;
        $this->meta_keyword = $this->$meta_keyword;
        $this->meta_description = $this->$meta_description;
    }

    function getCountProducts($publish = 1, $hide_product_not_avaible_stock = 0) {
        $add_where = "";
        if ($publish == 1) $add_where .= " AND prod.product_publish = '1' ";
        if ($hide_product_not_avaible_stock){
            $add_where .= " AND prod.product_quantity > 0";
        }
        $query = "SELECT count(pr_cat.product_id) FROM `#__jshopping_products_to_categories` AS pr_cat
                  INNER JOIN `#__jshopping_products` AS prod ON pr_cat.product_id = prod.product_id 
                  WHERE pr_cat.category_id = '".$this->_db->getEscaped($this->category_id)."' ".$add_where;
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }

    function getTreeChild() {
        $category_parent_id = $this->category_parent_id;
        $i = 0;
        $list_category[$i]->category_id = $this->category_id;
        $list_category[$i]->name = $this->name;
        $i++;
        while($category_parent_id) {
            $category = &JTable::getInstance('category', 'jshop');
            $category->load($category_parent_id);
            $list_category[$i]->category_id = $category->category_id;
            $list_category[$i]->name = $category->getName();
            $category_parent_id = $category->category_parent_id;
            $i++;
        }
        $list_category = array_reverse($list_category);
        return $list_category;
    }

    function getAllCategories() {
        $db =& JFactory::getDBO(); 
        $query = "SELECT category_id, category_parent_id FROM `#__jshopping_categories` WHERE category_publish = '1' ORDER BY category_ordering";
        $db->setQuery($query);
        return $db->loadObjectList();
    }

    function getChildCategories($order, $ordering = 'asc', $publish = 1) {
        $cats = $this->getSubCategories($this->category_id, $order, $ordering, $publish);
        return $cats;
    }

    function getSisterCategories($order, $ordering = 'asc', $publish = 1) {
        $cats = $this->getSubCategories($this->category_parent_id, $order, $ordering, $publish);
        return $cats;
    }

    function getTreeParentCategories() {
        $cats_tree = array(); 
        $category_parent = $this->category_id;
        while($category_parent) {
            $cats_tree[] = $category_parent;
            $query = "SELECT category_parent_id FROM `#__jshopping_categories` WHERE category_id = '" . $this->_db->getEscaped($category_parent) . "' AND category_publish = '1'";
            $this->_db->setQuery($query);
            $rows = $this->_db->loadObjectList();
            $category_parent = $rows[0]->category_parent_id;
        }
        return array_reverse($cats_tree);
    }

    function getProducts($order1 = null, $orderby1 = null, $order2 = null, $orderby2 = null, $limitstart = 0, $limit = 0) {
        $jshopConfig = &JSFactory::getConfig();
        $lang = &JSFactory::getLang();
        $adv_query = ""; $adv_from = ""; $adv_result = "";
        
        if ($jshopConfig->show_delivery_time){
            $adv_from .= "LEFT JOIN `#__jshopping_delivery_times` as dt ON dt.id = prod.delivery_times_id";
            $adv_result .= ", dt.`".$lang->get('name')."` as delivery_time";
        }
        
        if ($jshopConfig->hide_product_not_avaible_stock){
            $adv_query .= " AND prod.product_quantity > 0";
        }
        
        if ($order1){
        	$adv_query .= " ORDER BY ".$order1." ".$orderby1;
        	if ($order2){
        		$adv_query .= ", ".$order2." ".$orderby2;
        	}
        }
        if ($limit){
        	$adv_query .= " LIMIT " . $limitstart . ", " . $limit;
        }           
        
        $query = "SELECT prod.*, tax.tax_value as tax, (prod.product_price*".$jshopConfig->currency_value.") AS product_price, (prod.product_price*".$jshopConfig->currency_value.")/(1+tax.tax_value/100) AS price_netto, prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description $adv_result
                  FROM `#__jshopping_products` AS prod
                  LEFT JOIN `#__jshopping_products_to_categories` AS categ USING (product_id)
                  LEFT JOIN `#__jshopping_taxes` AS tax ON tax.tax_id = prod.product_tax_id
                  $adv_from                  
                  WHERE categ.category_id = '".$this->_db->getEscaped($this->category_id)."' AND prod.product_publish = '1' ".$adv_query;
        $this->_db->setQuery($query);
        $products = $this->_db->loadObjectList();        
        
        $userShop = &JSFactory::getUserShop();
        foreach ($products as $key=>$value){
            $products[$key]->product_price = getPriceDiscount($products[$key]->product_price, $userShop->percent_discount);
        }
        
        return $products;
    }
    
    function getDescriptionMainPage(){
        $jshopConfig = &JSFactory::getConfig();
        
        $query = "SELECT * FROM `#__jshopping_config_main_page` WHERE language = '".$jshopConfig->cur_lang."'";
        $this->_db->setQuery($query);
        $row = $this->_db->loadObject();        
        $this->description = $row->description;        
        $this->meta_title = $row->meta_title;
        $this->meta_keyword = $row->meta_keyword;
        $this->meta_description = $row->meta_description;
    }    
}
?>